Index: sandbox/workflow/trunk/inc/class.ui_ajaxinterface.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_ajaxinterface.inc.php	(revision 1452)
+++ sandbox/workflow/trunk/inc/class.ui_ajaxinterface.inc.php	(revision 2372)
@@ -11,5 +11,4 @@
 \**************************************************************************/
 
-require_once 'class.workflow_acl.inc.php';
 require_once 'common.inc.php';
 require_once 'engine/class.ajax_config.inc.php';
@@ -50,5 +49,5 @@
 	function set_wf_session()
 	{
-		$acl = new workflow_acl();
+		$acl = Factory::getInstance('workflow_acl');
 		$_SESSION['phpgw_info']['workflow']['server_root'] = PHPGW_SERVER_ROOT;
 		$_SESSION['phpgw_info']['workflow']['phpgw_api_inc'] = PHPGW_API_INC;
@@ -56,12 +55,12 @@
 		$vfs = createobject('phpgwapi.vfs');
 		$_SESSION['phpgw_info']['workflow']['vfs_basedir'] = $vfs->basedir;
-		$_SESSION['phpgw_info']['workflow']['server'] = $GLOBALS['phpgw_info']['server'];			
+		$_SESSION['phpgw_info']['workflow']['server'] = $GLOBALS['phpgw_info']['server'];
 		$_SESSION['phpgw_info']['workflow']['lang'] = $GLOBALS['lang'];
 		$_SESSION['phpgw_info']['workflow']['account_id'] = $GLOBALS['phpgw_info']['user']['account_id'];
-		$_SESSION['phpgw_info']['workflow']['user_groups'] = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserGroups($GLOBALS['phpgw_info']['user']['account_id']);
+		$_SESSION['phpgw_info']['workflow']['user_groups'] = Factory::getInstance('WorkflowLDAP')->getUserGroups($GLOBALS['phpgw_info']['user']['account_id']);
 		$user_is_admin = $acl->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']);
-		$_SESSION['phpgw_info']['workflow']['user_is_admin'] = $user_is_admin; 
+		$_SESSION['phpgw_info']['workflow']['user_is_admin'] = $user_is_admin;
 		$_SESSION['phpgw_info']['workflow']['user_can_admin_process'] = ($user_is_admin || ($GLOBALS['phpgw']->acl->check('admin_workflow',1,'workflow')));
-		$_SESSION['phpgw_info']['workflow']['user_can_admin_instance'] = ($user_is_admin || ($GLOBALS['phpgw']->acl->check('admin_instance_workflow',1,'workflow'))); 
+		$_SESSION['phpgw_info']['workflow']['user_can_admin_instance'] = ($user_is_admin || ($GLOBALS['phpgw']->acl->check('admin_instance_workflow',1,'workflow')));
 
 		$can_monitor = $acl->checkUserGroupAccessToType('MON', $GLOBALS['phpgw_info']['user']['account_id']);
@@ -118,5 +117,5 @@
 	{
 		$CSSName = "css/{$CSSName}.css";
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer = &Factory::getInstance('TemplateServer');
 		$CSSLink = $templateServer->getWebFile($CSSName);
 		$CSSFile = $templateServer->getSystemFile($CSSName);
Index: sandbox/workflow/trunk/inc/class.JobRunner.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.JobRunner.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.JobRunner.inc.php	(revision 2372)
@@ -43,5 +43,5 @@
 		$this->parameters = unserialize(base64_decode($parameters));
 		$this->parameters['currentDate'] = new DateTime($this->parameters['currentDate']);
-		$this->jobManager = &$GLOBALS['workflow']['factory']->getInstance('WorkflowJobManager');
+		$this->jobManager =& Factory::getInstance('WorkflowJobManager');
 	}
 
@@ -66,5 +66,11 @@
 	{
 		/* activate the security policy */
-		$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->enableSecurityPolicy();
+		Factory::getInstance('WorkflowSecurity')->enableSecurityPolicy();
+
+		/**
+		 * Since all jobs must run in process mode, e. g. it's user code,
+		 * we must enable the security.
+		 */
+		Security::enable();
 
 		if (!file_exists($this->parameters['file']))
@@ -94,7 +100,7 @@
 
 require_once 'common.inc.php';
-$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 
-$jobRunner = new JobRunner($argv[1]);
+$jobRunner = &Factory::newInstance('JobRunner', $argv[1]);
 $jobRunner->run();
 ?>
Index: sandbox/workflow/trunk/inc/class.ui_adminsource.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_adminsource.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_adminsource.inc.php	(revision 2372)
@@ -17,5 +17,4 @@
  */
 require_once dirname(__FILE__) . SEP . 'class.ui_ajaxinterface.inc.php';
-require_once dirname(__FILE__) . SEP . 'class.workflow_acl.inc.php';
 require_once 'engine' . SEP . 'config.ajax.inc.php';
 
@@ -43,5 +42,5 @@
 	function ui_adminsource()
 	{
-		$this->workflow_acl = new workflow_acl();
+		$this->workflow_acl = Factory::getInstance('workflow_acl');
 		$denyAccess = true;
 		if ($this->workflow_acl->checkWorkflowAdmin($_SESSION['phpgw_info']['workflow']['account_id']))
@@ -78,5 +77,5 @@
 	function form()
 	{
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
+		$smarty = Factory::getInstance('workflow_smarty', false);
 		$smarty->setHeader(workflow_smarty::SHOW_HEADER | workflow_smarty::SHOW_NAVIGATION_BAR | workflow_smarty::SHOW_FOOTER, $GLOBALS['phpgw_info']['apps']['workflow']['title'] . ' - ' . lang('Admin Processes Sources'));
 
Index: sandbox/workflow/trunk/inc/class.so_adminjobs.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_adminjobs.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.so_adminjobs.inc.php	(revision 2372)
@@ -10,7 +10,4 @@
 \**************************************************************************/
 
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php';
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'JobManager.php';
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php';
 
 /**
@@ -96,6 +93,6 @@
 		$this->isAdmin = $_SESSION['phpgw_info']['workflow']['user_is_admin'];
 		$this->acl = &$GLOBALS['ajax']->acl;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
-		$this->jobManager = new JobManager(&$this->db);
+		$this->db = &Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
+		$this->jobManager = &Factory::newInstance('JobManager');
 	}
 
@@ -229,5 +226,5 @@
 		$output = array();
 		$job = $this->jobManager->getJob($jobID);
-		$jobScheduler = &$GLOBALS['workflow']['factory']->getInstance('JobScheduler');
+		$jobScheduler =& Factory::getInstance('JobScheduler');
 		$totalTime = microtime(true);
 		$thread = $jobScheduler->execute($job, true);
Index: sandbox/workflow/trunk/inc/class.workflow_smarty.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_smarty.inc.php	(revision 1227)
+++ sandbox/workflow/trunk/inc/class.workflow_smarty.inc.php	(revision 2372)
@@ -11,5 +11,4 @@
 
 require_once 'smarty/Smarty.class.php';
-//require_once 'class.ui_ajaxinterface.inc.php';
 
 /**
Index: sandbox/workflow/trunk/inc/class.ui_move_instances.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_move_instances.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_move_instances.inc.php	(revision 2372)
@@ -36,5 +36,5 @@
 	{
 		$GLOBALS['phpgw_info']['flags'] = array('noheader' => false, 'nonavbar' => false, 'currentapp' => 'workflow');
-		$smarty = CreateObject('workflow.workflow_smarty');
+		$smarty = Factory::getInstance('workflow_smarty');
 
 		$javaScripts = $this->get_common_js();
Index: sandbox/workflow/trunk/inc/class.ui_adminactivities.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_adminactivities.inc.php	(revision 1710)
+++ sandbox/workflow/trunk/inc/class.ui_adminactivities.inc.php	(revision 2372)
@@ -2,5 +2,4 @@
 
 require_once dirname(__FILE__) . SEP . 'class.WorkflowUtils.inc.php';
-require_once dirname(__FILE__) . SEP . 'class.fsutils.inc.php'; /* toolkit for filesystem handling */
 require_once 'engine' . SEP . 'config.egw.inc.php';
 /**
@@ -73,5 +72,5 @@
 		parent::WorkflowUtils();
 
-		$this->workflow_acl = CreateObject('workflow.workflow_acl');
+		$this->workflow_acl = Factory::getInstance('workflow_acl');
 		$denyAccess = true;
 		if ($this->workflow_acl->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
@@ -106,8 +105,8 @@
 		}
 
-		$this->process_manager	= CreateObject('workflow.workflow_processmanager');
-		$this->activity_manager	= CreateObject('workflow.workflow_activitymanager');
-		$this->role_manager	= CreateObject('workflow.workflow_rolemanager');
-		$this->fs = new FsUtils(); /* gets instance */
+		$this->process_manager	= Factory::getInstance('workflow_processmanager');
+		$this->activity_manager	= Factory::getInstance('workflow_activitymanager');
+		$this->role_manager	= Factory::getInstance('workflow_rolemanager');
+		$this->fs = &Factory::newInstance('FsUtils'); /* gets instance */
 
 	}
@@ -374,5 +373,5 @@
 		// fill proc_bar
 		$this->t->set_var('proc_bar', $this->fill_proc_bar($proc_info));
-		
+
 		//collect some messages from used objects
 		$this->message[] = $this->activity_manager->get_error(false, _DEBUG);
@@ -380,5 +379,5 @@
 		$this->message[] = $this->role_manager->get_error(false, _DEBUG);
 
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer = &Factory::getInstance('TemplateServer');
 
 		// fill the general variables of the template
@@ -732,5 +731,5 @@
 			$this->translate_template('block_process_activities_header');
 			$this->t->parse('process_activities_header', 'block_process_activities_header', True);
-			$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+			$templateServer = &Factory::getInstance('TemplateServer');
 			foreach ($process_activities_data as $activity)
 			{
@@ -792,5 +791,5 @@
 				'trans_href_from'	=> $GLOBALS['phpgw']->link('/index.php', 'menuaction=workflow.ui_adminactivities.form&where2='. $where2 .'&sort_mode2='. $sort_mode2 .'&p_id='. $this->wf_p_id .'&find='. $find .'&where='. $where .'&sort_mode='. $this->sort_mode .'&activity_id='. $transition['wf_act_from_id']),
 				'trans_actFromName'	=> $transition['wf_act_from_name'],
-				'trans_arrow'		=> $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink('next.gif'),
+				'trans_arrow'		=> Factory::getInstance('TemplateServer')->generateImageLink('next.gif'),
 				'trans_href_to'		=> $GLOBALS['phpgw']->link('/index.php', 'menuaction=workflow.ui_adminactivities.form&where2='. $where2 .'&sort_mode2='. $sort_mode2 .'&p_id='. $this->wf_p_id .'&find='. $find .'&where='. $where .'&sort_mode='. $this->sort_mode .'&activity_id='. $transition['wf_act_to_id']),
 				'trans_actToName'	=> $transition['wf_act_to_name'],
@@ -1036,5 +1035,5 @@
 		$image_name = $proc_info['wf_normalized_name'] . SEP . 'graph' . SEP . $proc_info['wf_normalized_name'] . '.png';
 		$image = GALAXIA_PROCESSES . SEP . $image_name;
-		if ($GLOBALS['workflow']['factory']->getInstance('BrowserInfo')->isOpera())
+		if (Factory::getInstance('BrowserInfo')->isOpera())
 			$maximumDimension = 1000000;
 		else
@@ -1069,5 +1068,5 @@
 		}
 	}
-	
+
 	/**
 	 * Dislays the activity agents config rows
@@ -1090,5 +1089,5 @@
 			}
 			$this->translate_template('admin_agents');
-												$this->t->parse('agents_config_rows', 'admin_agents');
+			$this->t->parse('agents_config_rows', 'admin_agents');
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.workflow_wfruntime.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_wfruntime.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_wfruntime.inc.php	(revision 2372)
@@ -18,5 +18,5 @@
 		function workflow_wfruntime()
 		{
-			parent::WfRuntime($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::WfRuntime(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.WorkflowLDAP.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.WorkflowLDAP.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.WorkflowLDAP.inc.php	(revision 2372)
@@ -50,5 +50,5 @@
 	function WorkflowLDAP()
 	{
-		$this->dataSource = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
+		$this->dataSource =& Factory::getInstance('WorkflowObjects')->getLDAP();
 
 		/* get the required parameters */
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_user.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_user.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_user.php	(revision 2372)
@@ -94,5 +94,5 @@
 		$extraParams .= "&hideSectors=1";
 
-	$image = $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink('add_user.png');
+	$image = Factory::getInstance('TemplateServer')->generateImageLink('add_user.png');
 
 $output .= <<<EOF
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_state.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_state.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_state.php	(revision 2372)
@@ -46,5 +46,5 @@
 	$sql = "SELECT id_state, state_name FROM phpgw_cc_state WHERE id_country = 'BR' ORDER BY state_name";
 
-	$result = $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->query($sql);
+	$result = Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->query($sql);
 	$estados = array();
 	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_ldap_users.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_ldap_users.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_ldap_users.php	(revision 2372)
@@ -25,5 +25,5 @@
 {
     require_once $smarty->_get_plugin_filepath('function','html_options');
-	$imagesPath = substr($GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink(''), 0, -1);
+	$imagesPath = substr(Factory::getInstance('TemplateServer')->generateImageLink(''), 0, -1);
 
 	$requiredParams = array(
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_city.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_city.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_city.php	(revision 2372)
@@ -37,14 +37,14 @@
 		if (!array_key_exists($required, $params) || (empty($params[$required])))
 			$smarty->trigger_error("[wf_select_city] missing required parameter(s): $required", E_USER_ERROR);
-	
+
 	/* atribui valores default para os parâmetros não passados */
 	foreach ($defaultValues as $key => $value)
 		if (!isset($params[$key]))
 			$params[$key] = $value;
-	
+
 	/* extrai alguns parâmetros da matriz de parâmetros */
 	foreach ($extractParams as $extract)
 		$$extract = $params[$extract];
-	
+
 	/* parâmetros extras são "acumulados" em uma única variável */
 	$extraParams = array();
@@ -53,5 +53,5 @@
 			$extraParams[$key] = $value_params;
 
-	$db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID;
+	$db = &Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID;
 	if (isset($params['value']))
 	{
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_generic_select.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_generic_select.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_generic_select.php	(revision 2372)
@@ -53,5 +53,5 @@
 EOF;
 
-	$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+	$templateServer = &Factory::getInstance('TemplateServer');
 	$imageAdd = $templateServer->generateImageLink('add.png');
 	$imageRemove = $templateServer->generateImageLink('close.png');
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/prefilter.wf_default_template.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/prefilter.wf_default_template.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/prefilter.wf_default_template.php	(revision 2372)
@@ -31,5 +31,5 @@
 	{
 		/* get the header and footer location */
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer = &Factory::getInstance('TemplateServer');
 		$header = $templateServer->getSystemFile('processes/header.tpl');
 		$footer = $templateServer->getSystemFile('processes/footer.tpl');
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_redir_menu.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_redir_menu.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_redir_menu.php	(revision 2372)
@@ -53,5 +53,5 @@
 	$select_tag .= "<option value=\"og\">Organograma</option>";
 
-	$user_is_admin = $GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']);
+	$user_is_admin = Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']);
 	if ($user_is_admin || ($GLOBALS['phpgw']->acl->check('admin_workflow',1,'workflow'))) {
 		$select_tag .= "<option value=\"ad\">Administração</option>";
Index: sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_users.php
===================================================================
--- sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_users.php	(revision 795)
+++ sandbox/workflow/trunk/inc/smarty/wf_plugins/function.wf_select_users.php	(revision 2372)
@@ -16,5 +16,5 @@
 {
     require_once $smarty->_get_plugin_filepath('function','html_options');
-	$imagesPath = substr($GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink(''), 0, -1);
+	$imagesPath = substr(Factory::getInstance('TemplateServer')->generateImageLink(''), 0, -1);
 	$requiredParams = array(
 		'name');
Index: sandbox/workflow/trunk/inc/class.workflow_gui.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_gui.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_gui.inc.php	(revision 2372)
@@ -5,7 +5,5 @@
 
 	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'GUI' . SEP . 'GUI.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Process.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Instance.php');
-	require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'common' . SEP . 'WfSecurity.php');
+
 	/**
 	 * @package Workflow
@@ -20,5 +18,5 @@
 		function workflow_gui()
 		{
-			parent::GUI($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::GUI(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.bo_userinterface.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_userinterface.inc.php	(revision 2085)
+++ sandbox/workflow/trunk/inc/class.bo_userinterface.inc.php	(revision 2372)
@@ -10,10 +10,6 @@
 \**************************************************************************/
 
-require_once('class.so_userinterface.inc.php');
 require_once('class.bo_ajaxinterface.inc.php');
-require_once('class.Paging.inc.php');
-
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'GUI' . SEP . 'GUI.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
+
 /**
  * @package Workflow
@@ -43,7 +39,7 @@
 	function bo_userinterface()
 	{
-		parent::bo_ajaxinterface();	
-		$this->so = new so_userinterface();
-		$GLOBALS['ajax']->gui = new GUI($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		parent::bo_ajaxinterface();
+		$this->so = &Factory::getInstance('so_userinterface');
+		$GLOBALS['ajax']->gui = &Factory::newInstance('GUI');
 	}
 
@@ -68,5 +64,5 @@
 		$webserver_url = $_SESSION['phpgw_info']['workflow']['server']['webserver_url'];
 
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer =& Factory::getInstance('TemplateServer');
 		foreach ($result['data'] as $line)
 		{
@@ -120,17 +116,17 @@
 		$pid = $params['pid'];
 		$result = array();
-		
-		$process = new Process($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+
+		$process = &Factory::newInstance('Process');
 		$process->getProcess($pid);
 		$result['wf_procname'] = $process->name;
 		$result['wf_version'] = $process->version;
 		$result['wf_description'] = $process->description;
-		
-		$activ_manager = new ActivityManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+
+		$activ_manager = &Factory::newInstance('ActivityManager');
 		$result['wf_activities'] = $activ_manager->get_process_activities($pid);
-		
-		$this->disconnect_all();
-		
-		return $result; 
+
+		$this->disconnect_all();
+
+		return $result;
 	}
 
@@ -148,5 +144,5 @@
 		$itemsPerPage = isset($preferences['ui_items_per_page']) ? $preferences['ui_items_per_page'] : 15;
 		$lightVersion = ((isset($preferences['use_light_interface']) ? $preferences['use_light_interface'] : 0) == 1);
-		$paging = new Paging($itemsPerPage, $_POST);
+		$paging = Factory::newInstance('Paging', $itemsPerPage, $_POST);
 
 		/* define the sorting */
@@ -263,5 +259,5 @@
 				else
 					if ($row['wf_user'] != '')
-						$row['wf_user_fullname'] = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($row['wf_user']);
+						$row['wf_user_fullname'] = Factory::getInstance('WorkflowLDAP')->getName($row['wf_user']);
 
 				/* unset unneeded information */
@@ -495,8 +491,8 @@
 		}
 
-		$instance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$instance = &Factory::newInstance('Instance');
 		$instance->getInstance($instanceID);
 
-		$process = new Process($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$process = &Factory::newInstance('Process');
 		$process->getProcess($instance->pId);
 
@@ -508,7 +504,7 @@
 			'wf_instance_id' => $instance->instanceId,
 			'wf_priority' => $instance->priority,
-			'wf_owner' => $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($instance->owner),
+			'wf_owner' => Factory::getInstance('WorkflowLDAP')->getName($instance->owner),
 			'wf_next_activity' => $instance->nextActivity,
-			'wf_next_user' => $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($instance->nextUser),
+			'wf_next_user' => Factory::getInstance('WorkflowLDAP')->getName($instance->nextUser),
 			'wf_name' => $instance->name,
 			'wf_category' => $instance->category,
@@ -526,5 +522,5 @@
     		$result['wf_ended'] = "";
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		foreach ($instance->workitems as $line)
 		{
@@ -657,5 +653,5 @@
 		$cod_process = array();
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		$viewActivitiesID = array();
 		foreach ($result['data'] as $row)
@@ -726,5 +722,5 @@
 			/* paginate the result */
 			$itemsPerPage = isset($_SESSION['phpgw_info']['workflow']['user']['preferences']['ui_items_per_page']) ? $_SESSION['phpgw_info']['workflow']['user']['preferences']['ui_items_per_page'] : 15;
-			$paging = new Paging($itemsPerPage, $_POST);
+			$paging = Factory::newInstance('Paging', $itemsPerPage, $_POST);
 			$output['instances'] = $paging->restrictItems($output['instances']);
 			$output['paging_links'] = $paging->commonLinks();
@@ -740,5 +736,5 @@
 	/**
 	 * Aplicacoes externas do usuario
-	 * @return array 
+	 * @return array
 	 * @access public
 	 */
@@ -746,5 +742,5 @@
 	{
 		$webserver_url = $_SESSION['phpgw_info']['workflow']['server']['webserver_url'];
-		$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+		$templateServer = &Factory::getInstance('TemplateServer');
 
 		/* load the sites that the user can access */
@@ -1070,5 +1066,5 @@
 	function callVoipConnect($params)
 	{
-		$cachedLDAP = $GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_LDAP);
 
Index: sandbox/workflow/trunk/inc/class.Logger.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.Logger.inc.php	(revision 900)
+++ sandbox/workflow/trunk/inc/class.Logger.inc.php	(revision 2372)
@@ -80,5 +80,5 @@
 	{
 
-		$this->db =& $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID;
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID;
 
 		if(!empty($curProcessName)){
Index: sandbox/workflow/trunk/inc/class.bo_adminjobs.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_adminjobs.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_adminjobs.inc.php	(revision 2372)
@@ -11,6 +11,4 @@
 
 require_once 'class.bo_ajaxinterface.inc.php';
-require_once 'class.so_adminjobs.inc.php';
-require_once 'nano/JSON.php';
 
 /**
@@ -36,5 +34,5 @@
 	{
 		parent::bo_ajaxinterface();
-		$this->so = new so_adminjobs();
+		$this->so = &Factory::getInstance('so_adminjobs');
 	}
 
@@ -100,5 +98,5 @@
 		/* paginate the result */
 		$logEntriesPerPage = 30;
-		$paging = &$GLOBALS['workflow']['factory']->newInstance('Paging', $logEntriesPerPage, $params);
+		$paging =& Factory::newInstance('Paging', $logEntriesPerPage, $params);
 		$logs = $paging->restrictItems($logs);
 
Index: sandbox/workflow/trunk/inc/class.so_external_applications.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.so_external_applications.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.so_external_applications.inc.php	(revision 2372)
@@ -130,5 +130,5 @@
 		$this->isAdmin = $_SESSION['phpgw_info']['workflow']['user_is_admin'];
 		$this->acl = &$GLOBALS['ajax']->acl;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
 		$this->EXTERNAL_APPLICATION_PATH = $_SESSION['phpgw_info']['workflow']['server']['files_dir'] . '/workflow//workflow/external_applications';
 	}
